#include <stdio.h>
#include <string.h>
#include "compat.h"
#include "global.h"
#include "errors.h"

/*#define NUMFDEBUG	1	/* */

char *
makenumformat(str,type)
char *str;
int type;
{
	char	*cp, tmp[10], *Z, *ret;
	int	size,err,i,p,z,c,e,dbp,dap;

	cp = str;
	SKIP_SPACES(cp);

	if(*cp == '\0'){
		Err(ErrUsynempty,NULL_char);
		return(NULL_char);
	}

	i = 0;		/*size*/
	p = 0;		/* point found */
	z = 0;		/* leading zero or digit */
	c = 0;		/* currency */
	e = 0;		/* exponential*/
	dbp = 0;	/* digits before point */
	dap = 0;	/* digits after point */
	err = 0;	/* error found */

	Z = "";

	while(*cp != '\0'){
		i++;
		switch(*cp){
		case '0':
			if(dap || dbp || c) { err =1; break; }
			z = 1;
			Z = "0";
			dbp++;
			break;
		case '9':
			if(p) dap++;
			else  dbp++;
			break;
		case '.':
			if(p || !dbp) { err =1; break; }
			p = 1;
			break;
		case '$':
			if(c) { err =1; break; }
			if(z) { err =1; break; }
			c = i;
			break;
		case 'E':
		case 'e':
			if(!dap || c){ err =1; break; }
			if(dbp > 1) { err =1; break; }
			e = 1;
			break;
		default:
			err = 1;
			break;
		}
		if(err) break;
		if(e) break;
		cp++;
	}

#ifdef NUMFDEBUG
	printf("\nz = %d, p = %d, c = %d, e = %d, dbp = %d, dap = %d\n\n",
	z,p,c,e,dbp,dap);fflush(stdout);
#endif

	if(c && c != 1 && c != i) /* check position */
		err = c;

	if(err){
#ifdef NUMFDEBUG
		printf("err, i = %d\n",i);fflush(stdout);
#endif
		sprintf(tmp,"%d",i);
		Err(ErrUnumformat,tmp);
		return(NULL_char);
	}

	size = 7; /* % + zero + dbp + point + dap + format + null */

	if(c) size += (1 + strlen(def_currency)); /* space + $ */
		
	if((ret = (char *)malloc(size)) == NULL){
		Err(ErrIalloc,"(numformat)");
		return(NULL_char);
	}


	if(type == NUMF_FLOAT){
		if(e)
			sprintf(tmp,"%%.%dE",dap);
		else if(p)
			sprintf(tmp,"%%%s%d.%df",Z,dbp,dap);
		else
			sprintf(tmp,"%%%s%d.0f",Z,dbp);
	} else {
		sprintf(tmp,"%%%s%dd",Z,dbp);
	}

	if(c){
		if(c == 1)
			sprintf(ret,"%s %s",def_currency,tmp);
		else
			sprintf(ret,"%s %s",tmp,def_currency);
	} else
		strcpy(ret,tmp);

#ifdef NUMFDEBUG
	printf("format:%s:\n",ret);
#endif
	return(ret);
}

char *
makefilename(fname,suf)
char *fname;
char *suf;
{
	static char tmp[128];
	char *fp, *sp;

	if(fname == NULL_char || suf == NULL_char)
		return(fname);

	if(strlen(suf) == 0)
		return(fname);

	sp = suf;
	if(*sp == '.')
		sp++;

	if((fp = strrchr(fname,'.')) != NULL){
		fp++;
		if(strcmp(fp,sp) == 0)
			return(fname);
	}

	sprintf(tmp,"%s.%s",fname,sp);
	return(tmp);
}

char *
prependdir(fname,dir)
char *fname;
char *dir;
{
	static char tmp[256];
	char *fp;

	if(fname == NULL_char || *fname == '\0')
		return(fname);

	if(dir == NULL_char || *dir == '\0')
		return(fname);

	fp = fname;

	if(*fp != '+')
		return(fname);

	fp++;

	sprintf(tmp,"%s/%s",dir,fp);
	return(tmp);
}

int
max(v1,v2)
int	v1;
int	v2;
{
	if (v1 > v2)
		return(v1);
	return(v2);
}

char *
copy_str(from)
char *from;
{
	char *ret;

	if(from == NULL_char)
		return(NULL_char);

	if((ret = (char *)malloc(strlen(from)+1)) == NULL){
		Err(ErrIalloc,"(copy_str)");
		return(NULL_char);
	}

	*ret = '\0';
	strcpy(ret,from);

	return(ret);
}

void
free_char(str)
char *str;
{
	if(str == NULL_char)
		return;

	free((FREETYPE *)str);
}
