#include <stdio.h>
#include <msql.h>
#include "config.h"
#include "compat.h"
#include "global.h"

static int	openhost();
static int	opendb();
static void	closehost();


int
connect_db()
{
	Connected = FALSE;
	Initial = FALSE;

	if(def_dbname[0] == '\0'){
		Err(ErrUdbnoname,NULL_char);
		return(RET_ERR);
	}

	if(HostChanged || SQLsock < 0) {
		Out("\nOpen host: ");Out(def_host);Out(" - ");
		if(openhost(def_host) == RET_ERR)
			return(RET_ERR);
		HostChanged = FALSE;
		Out("Ok\n");
	}

	Out("\nOpen DB: "); Out(def_dbname); Out(" ...\n");

	if(opendb(def_dbname) == RET_ERR)
		return(RET_ERR);

	Out("\n");

	Connected = TRUE;

	return(RET_OK);
}

int
disconnect_db()
{
	closehost();
}

static int
openhost(host)
char *host;
{
	if(SQLsock > -1)
		closehost();

	if(strcasecmp(host,DEF_HOSTNAME) == 0)
		SQLsock = msqlConnect(NULL);
	else
		SQLsock = msqlConnect(host);


	if(SQLsock < 0){
		Err(ErrSconnect,msqlErrMsg);
		return(RET_ERR);
	}
	return(RET_OK);
}

static int
opendb(db)
char *db;
{
	if (msqlSelectDB(SQLsock, db) < 0){
		Err(ErrSseldb,msqlErrMsg);
		return(RET_ERR);
	}
	return(RET_OK);
}


static void
closehost()
{
	if(SQLsock > -1)
		msqlClose(SQLsock);
	Connected = FALSE;
	SQLsock = -1;
}
